stages:
  - test
  - build docker image
  - deploy image

test:
  stage: test
  image: python:3.7.4-alpine3.10
  script:
    - pip install -r requirements.txt
    - python -m unittest discover

build image:
  services:
    - docker:dind
  image: docker:stable
  stage: build docker image
  script:
    - docker build -t registry.gitlab.com/knowledge21/csd/classes/csd_202007/yoshida_comission_calculator .
    - docker login -u=$CI_REGISTRY_USER -p=$CI_REGISTRY_PASSWORD registry.gitlab.com
    - docker push registry.gitlab.com/knowledge21/csd/classes/csd_202007/yoshida_comission_calculator

deploy image:
  stage: deploy image
  when: manual
  before_script:
    - mkdir -p ~/.ssh
    - echo "$DEPLOY_SERVER_PRIVATE_KEY" | tr -d '\r' > ~/.ssh/id_rsa
    - chmod 600 ~/.ssh/id_rsa
    - eval "$(ssh-agent -s)"
    - ssh-add ~/.ssh/id_rsa
    - ssh-keyscan -H $DEPLOYMENT_SERVER_IP >> ~/.ssh/known_hosts
  script:
    - ssh $DEPLOYMENT_SERVER_USER@$DEPLOYMENT_SERVER_IP "docker login -u=$CI_REGISTRY_USER -p=$CI_REGISTRY_PASSWORD registry.gitlab.com && docker stop \`docker ps -a -q\` && docker run -d -p 8083:8000 registry.gitlab.com/knowledge21/csd/classes/csd_202007/yoshida_comission_calculator"